﻿Imports System.Net
Imports System.Net.WebUtility
Imports System.IO
Imports System.Net.Sockets
Imports System.Text
Imports WFS_API_demo.My
Imports System.IO.Compression
Imports System.ComponentModel
Imports System.Runtime.InteropServices.JavaScript.JSType
Public Class Form1
    Public wfsConnection As Object = Nothing, sessionURL As String = "", myID As String = "12345", theReply As String

    Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        ' OPEN A WORDFAST SERVER SESSION

        Dim theQuery As String = ""

        ' create a wfsConnection object
        If InStr(1, TextBox1.Text, "http://", 1) = 0 Or InStr(TextBox1.Text, "@") = 0 Then
            MsgBox("Please enter a connection!")
            Exit Sub
        End If
        Try
            wfsConnection = Nothing
            wfsConnection = CreateObject("Msxml2.XMLHTTP.6.0")
            waitMilliSeconds(10)
        Catch ex As Exception
            MsgBox("Error creating HTTP object as MSXML2.ServerXMLHTTP.6.0" & vbCrLf & vbCrLf & ex.ToString)
            wfsConnection = Nothing
            Exit Sub
        End Try


        ' start the session with the account. "now" is used to sidestep the local cache
        Dim strPara As String = Mid(TextBox1.Text, 1, InStr(TextBox1.Text, "@") - 1)
        strPara = Replace(strPara, "http://", "",,, 1)
        sessionURL = "http://" & Mid(TextBox1.Text, InStr(TextBox1.Text, "@") + 1) & "/?now=" & Mid(CStr(Rnd()), 3)

        ' the command 25 ends any previous session
        theQuery = sessionURL & "&cmd=25"
        sendHTTPrequest(theQuery)

        theQuery = sessionURL & "&cmd=22&para=" & UrlEncode(strPara)
        sendHTTPrequest(theQuery)

        waitMilliSeconds(1000)

        Dim strReply As String
        strReply = getWFSreply()
        If strReply.Length < 1 Then
            MsgBox("No reply from the server!" & vbCrLf & vbCrLf & strReply)
            Exit Sub
        End If
        If InStr(strReply, "[1.22") > 0 Then
            MsgBox("The connection was successful. Now trying to get some information from the server")
            Button2.Enabled = True
            Button3.Enabled = True
        Else
            MsgBox("The connection failed. See WFS' ""Activity"" pane for clues.")
            Button2.Enabled = False
            Button3.Enabled = False
            wfsConnection = Nothing
            Exit Sub
        End If

        ' this command asks the server for some information
        ' it also demonstrates how to POST data, rather than use a GET method
        'wfsConnection = Nothing
        'wfsConnection = CreateObject("Msxml2.XMLHTTP.6.0")
        'waitMilliSeconds(10)

        wfsConnection.Open("POST", sessionURL)
        wfsConnection.setRequestHeader("From", myID)
        theQuery = "cmd=50&para=TMFileName;TMFileSize;gloFileName;GloFileSize;CountTUs;CountEntries;TMFileFormat;GloFileFormat;TMLangID;GloLangID;UserID;SVersion;IsReadWrite;IsPublicReadWrite;CanWriteTM;CanWritePublicTM;IndexUsed;FuzzyThreshold"
        wfsConnection.send(System.Text.Encoding.Unicode.GetBytes(theQuery))
        waitMilliSeconds(10)

        ' this command tells the server we expect some data back. 5000 is the timeout, 2000 is the max size of the buffer returning data
        theQuery = sessionURL & "&waitdata=" & UrlEncode("5000,2000")
        sendHTTPrequest(theQuery)

        strReply = getWFSreply()
        If InStr(strReply, ";") > 0 Then
            Dim i As Integer, myArray() As String
            myArray = Split(strReply, ";")
            strReply = ""
            For i = 0 To myArray.Length - 1
                strReply &= myArray(i) & vbCrLf
                If i > 20 Then Exit For
            Next
            MsgBox(strReply,, "Reply from the server:")
        End If
        'wfsConnection = Nothing
    End Sub

    Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim theQuery As String

        ' this command 5 looks up segments in the TM


        theQuery = sessionURL & "&cmd=5&para=" & UrlEncode(TextBox2.Text)
        sendHTTPrequest(theQuery)

        ' this command tells the server we expect some data back. 5000 is the timeout in milliseconds, 16000 is the max size of the buffer returning data, in characters
        theQuery = sessionURL & "&waitdata=" & UrlEncode("5000,16000")
        sendHTTPrequest(theQuery)

        ' now let's get the reply
        theReply = getWFSreply()
        theReply = Replace(theReply, vbCr, vbCrLf)
        theReply = Mid(theReply, 1, 800)

        Form2.ShowDialog()

        'wfsConnection = Nothing
    End Sub

    Public Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Dim theQuery As String

        theQuery = sessionURL & "&cmd=15&para=" & UrlEncode(TextBox3.Text)
        sendHTTPrequest(theQuery)

        ' this command tells the server we expect some data back. 5000 is the timeout in milliseconds, 16000 is the max size of the buffer returning data, in characters
        theQuery = sessionURL & "&waitdata=" & UrlEncode("5000,16000")
        sendHTTPrequest(theQuery)
        ' give the server a little more time to complete the search
        waitMilliSeconds(1000)

        theReply = getWFSreply()

        Dim myArray() As String, myArray2() As String, i As Integer, j As Integer
        myArray = Split(theReply, vbCr)
        If myArray.Length > 0 Then
            theReply = ""
            For i = 0 To myArray.Length - 1
                myArray2 = Split(myArray(i), vbTab)
                If myArray2.Length > 5 Then
                    If myArray2(4).Length > 160 Then myArray2(4) = Mid(myArray2(4), 1, 160) & "..."
                    If myArray2(6).Length > 160 Then myArray2(6) = Mid(myArray2(6), 1, 160) & "..."
                    theReply &= "SOURCE: " & myArray2(4) & vbCrLf & "TARGET: " & myArray2(6) & vbCrLf & vbCrLf

                    ' this is to show a browser with key words highlighted
                    ' theReply &= "<tr><td>SOURCE</td><td>" & myArray2(4) & "</td><tr><td>TARGET</td>" & myArray2(6) & "</td></tr>"
                    j += 1
                End If
                If j > 10 Then Exit For
            Next
        End If
        Form2.ShowDialog()
    End Sub

    Function getWFSreply() As String
        ' get a reply from WFS

        ' first make sure the HTTP connection has been completed
        Dim iLoops As Integer = 0

        Do While wfsConnection.readystate < 4
            waitMilliSeconds(500)
            iLoops += 1
            If iLoops > 10 Then
                MsgBox("The server did not reply! The session will be closed.")
                wfsConnection = Nothing
                Return ""
            End If
        Loop

        ' OK, so now get the HTTP reply
        Dim theReply As String = ""

        Try
            theReply = wfsConnection.responsetext
        Catch ex As Exception
            MsgBox("Error getting the HTTP reply!: " & sessionURL & vbCrLf & vbCrLf & ex.ToString)
            Return ""
        End Try

        Return theReply

    End Function
    Sub waitMilliSeconds(msSeconds As Integer)
        Application.DoEvents()
        System.Threading.Thread.Sleep(msSeconds)
        Application.DoEvents()
    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        Dim theConfig As String
        theConfig = TextBox1.Text & vbTab & TextBox2.Text & vbTab & TextBox3.Text

        Try
            Using sr As New StreamWriter("demo.ini")
                sr.WriteLine(theConfig)
                sr.Close()
                sr.Dispose()
            End Using
        Catch ex As Exception
        End Try

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim theString As String = ""
        Try
            Using sr As New StreamReader("demo.ini")
                theString = sr.ReadToEnd()
                sr.Close()
                sr.Dispose()
            End Using
        Catch ex As Exception
        End Try

        If theString Is Nothing Then Exit Sub

        Dim myArray() As String = Split(theString, vbTab)
        If myArray.Length > 2 Then
            TextBox1.Text = myArray(0)
            TextBox2.Text = myArray(1)
            TextBox3.Text = myArray(2)
        End If
    End Sub
    Sub sendHTTPrequest(theQuery As String)
        If wfsConnection Is Nothing Then
            Try
                wfsConnection = CreateObject("Msxml2.XMLHTTP.6.0")
                waitMilliSeconds(10)
            Catch ex As Exception
                MsgBox("Could create a Msxml2.XMLHTTP.6.0 object!")
                End
            End Try

        End If

        wfsConnection.Open("GET", theQuery, False)
        wfsConnection.setRequestHeader("From", myID)
        wfsConnection.send
        waitMilliSeconds(10)
    End Sub
End Class
